Public Class Chat

    Private Loc_Index As Integer
    Private Loc_Main As Boolean
    Private In_data() As String
    Private Loc_user As MainF.User_Type

    Friend Property Main() As Boolean
        Get
            Return Loc_Main
        End Get
        Set(ByVal Value As Boolean)
            Loc_Main = Value
        End Set
    End Property

    Friend Property Index() As Integer
        Get
            Return Loc_Index
        End Get
        Set(ByVal Value As Integer)
            Loc_Index = Value
        End Set
    End Property

    Friend Property Pvt_User() As MainF.User_Type
        Get
            Return Loc_user
        End Get
        Set(ByVal Value As MainF.User_Type)
            Loc_user = Value
        End Set
    End Property

    Public Sub New_data(ByVal Data As String)
        Dim tmp_start As Integer
        In_data = Split(Data, ":", 3, CompareMethod.Text)
        tmp_start = Len(Chat_Box.Text)
        Chat_Box.SelectionStart = tmp_start
        Chat_Box.SelectedText = In_data(2) & vbCrLf
        Chat_Box.SelectionStart = tmp_start
        Chat_Box.SelectionLength = Len(Chat_Box.Text) - tmp_start
        For Each tmp_user As MainF.User_Type In User
            If tmp_user.IP.Equals(Net.IPAddress.Parse(In_data(1))) Then
                Chat_Box.SelectionColor = Color.FromArgb(tmp_user.T_Colour)
            End If
        Next
        Chat_Box.SelectionStart = tmp_start
        Chat_Box.ScrollToCaret()
    End Sub

    Private Sub Chat_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        AddHandler Me.Closing, AddressOf Me.Chat_Cancel
        If Loc_Main Then
            Me.Text = "Main Chat"
        Else
            Me.Text = "Chat :" & Loc_user.Name
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub

    Protected Sub Chat_Cancel(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        Dim tmp_msg As MsgBoxResult
        e.Cancel = False
        If Loc_Main Then
            tmp_msg = MsgBox("This will log you out. Are you Sure?", MsgBoxStyle.OkCancel, "LOG OUT")
            If tmp_msg = MsgBoxResult.Cancel Then
                e.Cancel = True
            Else
                Call Main_F.Logout(sender, e)
            End If
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Send_Box.TextLength > 0 Then
            If Loc_Main Then
                Dim Dest_IP As New Net.IPEndPoint(Net.IPAddress.Parse("255.255.255.255"), L_Port)
                Main_F.UDPSock.Send("PUBM:" & User(0).IP.ToString & ":" & User(0).Name & ":" & Send_Box.Text, Dest_IP)
            Else
                Dim Dest_IP As New Net.IPEndPoint(Loc_user.IP, L_Port)
                Main_F.UDPSock.Send("PVTM:" & User(0).IP.ToString & ":" & User(0).Name & ":" & Send_Box.Text, Dest_IP)
            End If
            Send_Box.Text = ""
        End If
    End Sub

    Private Sub Send_Box_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Send_Box.KeyPress
        If e.KeyChar = Chr(13) Then
            Call Button1_Click(sender, e)
            e.Handled = True
        End If
    End Sub

    Private Sub Chat_Box_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Chat_Box.KeyDown
        e.Handled = True
        Send_Box.Focus()
    End Sub

    Private Sub Chat_Box_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Chat_Box.KeyPress
        e.Handled = True
        Send_Box.Focus()
    End Sub

    Private Sub Chat_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Close_Chat(Loc_Index)
    End Sub
End Class

