' General Variable's and functions relating to the application are in this module
' Although some Functions are form specific, I've rather put all my functions in
' this module and have only the Form event subs in the form.

Module General
    Public L_Port As Integer
    Public Subnet As Net.IPAddress
    Public User() As MainF.User_Type
    Public Chat_forms() As Chat
    Public File_forms() As Files
    Public Main_F As MainF
    Public L_IP As Net.IPAddress

    Public Function Close_Chat(ByVal Index As Integer) As Boolean
        Dim Tmp_Int As Integer
        Try
            Chat_forms(Index).Dispose()
            Chat_forms(Index) = Nothing
        Catch ex As Exception
            'ignore - it's closed
        End Try
        For Each PVT_Chat As Chat In Chat_forms
            Try
                If PVT_Chat.Index > Tmp_Int Then Tmp_Int = PVT_Chat.Index
            Catch ex As Exception
                'ignore - it's closed
            End Try
        Next
        ReDim Preserve Chat_forms(Tmp_Int)
    End Function
    Public Function Close_File(ByVal Index As Integer) As Boolean
        Dim Tmp_Int As Integer
        Try
            File_forms(Index).Dispose()
            File_forms(Index) = Nothing
        Catch ex As Exception
            'ignore as it's closed already..
        End Try
        For Each PVT_File As Files In File_forms
            Try
                If PVT_File.Index > Tmp_Int Then Tmp_Int = PVT_File.Index
            Catch ex As Exception
                'ignore as it's closed
            End Try
        Next
        ReDim Preserve File_forms(Tmp_Int)
    End Function

    Public Function Update_Users(ByVal Refresh As Boolean, Optional ByVal New_user As Integer = 0) As Boolean
        If Refresh Then
            With Main_F.User_list
                .BeginUpdate()
                .ClearSelected()
                .Items.Clear()
                For Each Tmp_User As MainF.User_Type In User
                    If Not Tmp_User.Hidden Then
                        .Items.Add(Tmp_User.Name)
                    End If
                Next
                .EndUpdate()
            End With
        Else
            Main_F.User_list.Items.Add(User(New_user).Name)
        End If
    End Function

    Public Function Delete_Users(ByVal U_Name As String) As Boolean
        Try
            With Main_F.User_list
                .BeginUpdate()
                .ClearSelected()
                .Items.Remove(U_Name)
                .EndUpdate()
            End With
            Delete_Users = True
        Catch ex As Exception
            Delete_Users = False
        End Try
    End Function

    Public Function Return_File(ByVal FullDirFile As String) As String
        Dim Dir_Struc() As String
        Dir_Struc = Split(FullDirFile, "\", -1, CompareMethod.Text)
        Return Dir_Struc(UBound(Dir_Struc))
    End Function

End Module
