' FIRSTLY Thanks goto HannesTheGreat from Codeguru.com for giving me the
' inspiration to rewrite this little proggy in VB.Net
'Many thanks also go out to the Members of Codeguru that assisted,
'I've tried to remember to mention each in the areas that you assited me in,
'But if i forgot please dont shoot me...

Imports VB = Microsoft.VisualBasic

Public Class MainF
    Public Structure User_Type
        Dim Local As Boolean
        Dim Name As String
        Dim IP As Net.IPAddress
        Dim Ignore As Boolean
        Dim Hidden As Boolean
        Dim T_Colour As Integer
    End Structure

    Public WithEvents UDPSock As UDPSocket_Buffer
    Private WithEvents Login_Form As New Login_page
    Private Logged_In As Boolean
    Private Pvt_Bool As Boolean
    Private Pvt_Int As Integer
    Private U_list_selected As Integer
    Private Rem_Host As String
    Private Rem_Port As Integer

    Private Sub MainF_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Tray_icon.Visible = False
        Call LogoutToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub MainF_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Tray_icon.BalloonTipTitle = "Ip Chat V4"
        Tray_icon.BalloonTipText = "IP Chat V4.001 - VB.NET 2005" & vbCrLf & "Written by Richard Newcombe"
        Tray_icon.Icon = Me.Icon
        Tray_icon.Text = "IP Chat V4"
        Tray_icon.Visible = True
        Tray_icon.ShowBalloonTip(5000)
        Tray_icon.ContextMenuStrip = Tray_popup
        ShowInTaskBarToolStripMenuItem.Checked = True
        UDPSock = New UDPSocket_Buffer
        ReDim Chat_forms(0)
        ReDim File_forms(0)
        Main_F = Me
        Call LoginToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ShowInTaskBarToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowInTaskBarToolStripMenuItem.Click
        ShowInTaskBarToolStripMenuItem.Checked = Not ShowInTaskBarToolStripMenuItem.Checked
        Me.ShowInTaskbar = ShowInTaskBarToolStripMenuItem.Checked
    End Sub

    Private Sub PopupWhenNewMessageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PopupWhenNewMessageToolStripMenuItem.Click
        PopupWhenNewMessageToolStripMenuItem.Checked = Not PopupWhenNewMessageToolStripMenuItem.Checked
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click
        Me.Close()
    End Sub

    Private Sub LoginToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoginToolStripMenuItem.Click
        Login_Form.MdiParent = Me
        Login_Form.Show()
    End Sub

    Private Sub OpenMainToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenMainToolStripMenuItem.Click
        Me.WindowState = FormWindowState.Normal
    End Sub

    Private Sub User_list_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles User_list.Click
        If User_list.SelectedIndex <> -1 Then
            User_list.ContextMenuStrip = User_Popup
        End If
    End Sub

    Private Sub Login_Form_Login_event(ByVal Login As Boolean) Handles Login_Form.Login_event
        If Login Then
            Logged_In = True
            UDPSock.Init(L_Port)
            Call Search_L_N()
            Chat_forms(0) = New Chat
            With Chat_forms(0)
                .MdiParent = Me
                .Index = 0
                .Main = True
                .PVT_user = User(0)
                .Show()
            End With
            Update_Users(True)
        End If
    End Sub

    Private Sub UDPSock_Data_Arrival(ByVal Data As String, ByVal Source As System.Net.IPAddress) Handles UDPSock.Data_Arrival
        ' Most of the communication takes place in this Event...
        Dim Net_Data() As String
        Net_Data = Split(Data, ":", -1, CompareMethod.Text)
        Select Case Net_Data(0)
            Case "FILE" ' "FILE:[IP]:[Name]:[Port]:[File Name]"
                For Each Tmp_user As MainF.User_Type In User
                    If Tmp_user.Name.Equals(Net_Data(2)) Then
                        If Not Tmp_user.Ignore Then
                            Pvt_Int = UBound(File_forms) + 1
                            ReDim Preserve File_forms(Pvt_Int)
                            File_forms(Pvt_Int) = New Files
                            Rem_Host = Net_Data(1)
                            Rem_Port = CInt(Net_Data(3))
                            With File_forms(Pvt_Int)
                                .MdiParent = Me
                                .Index = Pvt_Int
                                .FileName = Net_Data(4)
                                .Init(Files.Trans_State.Recv, Rem_Host, Rem_Port)
                                .Show()
                            End With
                        End If
                    End If
                Next
            Case "PUBM" ' "PUBM:[IP]:[Name]:Msg"
                For Each Tmp_user As MainF.User_Type In User
                    If Tmp_user.Name.Equals(Net_Data(2)) Then
                        If Not Tmp_user.Ignore Then
                            For Each Chat_frm As Chat In Chat_forms
                                If Chat_frm.Main Then
                                    Chat_frm.New_data(Data)
                                End If
                            Next
                        End If
                    End If
                Next
            Case "PVTM" ' "PVTM:[IP]:[Name]:Msg"
                Pvt_Bool = True
                For Each Tmp_user As MainF.User_Type In User
                    If Tmp_user.Name.Equals(Net_Data(2)) Then
                        If Not Tmp_user.Ignore Then
                            For Each Chat_frm As Chat In Chat_forms
                                If Chat_frm.Pvt_User.Name.Equals(Net_Data(2)) Then
                                    Chat_frm.New_data(Data)
                                    Pvt_Bool = False
                                    Exit For
                                End If
                            Next
                            If Pvt_Bool Then
                                Pvt_Int = UBound(Chat_forms) + 1
                                ReDim Preserve Chat_forms(Pvt_Int)
                                Chat_forms(Pvt_Int) = New Chat
                                With Chat_forms(Pvt_Int)
                                    .MdiParent = Me
                                    .Index = Pvt_Int
                                    .Main = False
                                    .Pvt_User = Tmp_user
                                    .Show()
                                End With
                            End If
                        End If
                    End If
                Next
            Case "LOGI" ' "LOGI:[IP]:[Name]:[Color]:[Hidden]
                If Not User(0).IP.Equals(Source) Then
                    If Add_User(Data) Then
                        New_User(Source)
                    End If
                End If
            Case "LOGO" ' "LOGO:[IP]:[Name]
                If Not User(0).IP.Equals(Source) Then
                    Call Del_User(Data)
                End If
            Case "USER" ' "USER:[IP]:[Name]:[Color]:[Hidden]
                If Not User(0).IP.Equals(Source) Then
                    Call Add_User(Data)
                End If
        End Select
    End Sub
    Public Sub Logout(ByVal Sender As System.Object, ByVal e As System.EventArgs)
        Call LogoutToolStripMenuItem_Click(Sender, e)
    End Sub

    Private Sub LogoutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LogoutToolStripMenuItem.Click
        If Logged_In Then
            Log_out()
            LoginToolStripMenuItem.Enabled = True
            LogoutToolStripMenuItem.Enabled = False
            UDPSock.Close()
            User_list.Items.Clear()
            Logged_In = False
        End If
    End Sub

    Private Sub UserColorToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UserColorToolStripMenuItem.Click
        CD1.ShowDialog()
        User(0).T_Colour = CD1.Color.ToArgb
    End Sub

    Private Sub IgnoreUserToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IgnoreUserToolStripMenuItem.Click
        Dim Tmp_Name As String
        Tmp_Name = Me.User_list.Items(User_list.SelectedIndex).ToString
        For Each Tmp_User As User_Type In User 'Find user and set the Ignore option
            If Tmp_Name = Tmp_User.Name Then
                Tmp_User.Ignore = Not Tmp_User.Ignore
                Exit For
            End If
        Next Tmp_User
    End Sub

    Private Sub User_list_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles User_list.MouseDown
        If User_list.SelectedIndex < 0 Then
            User_list.ContextMenuStrip = Nothing
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            For Each Tmp_User As User_Type In User
                If Tmp_User.Name.Equals(User_list.SelectedItem.ToString) Then
                    If Tmp_User.Ignore Then 'Adjust caption according to ignore Status..
                        IgnoreUserToolStripMenuItem.Text = "Accept User"
                    Else
                        IgnoreUserToolStripMenuItem.Text = "Ignore User"
                    End If
                    Exit For
                End If
            Next
            User_list.ContextMenuStrip = User_Popup
        End If
    End Sub

    Private Sub PrivateChatToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrivateChatToolStripMenuItem.Click
        For Each Tmp_Chat As Chat In Chat_forms
            If Tmp_Chat.PVT_user.Name.ToString.Equals(User_list.SelectedItem.ToString) Then
                Tmp_Chat.Show()
                Exit Sub
            End If
        Next
        Pvt_Int = UBound(Chat_forms) + 1
        ReDim Preserve Chat_forms(Pvt_Int)
        Chat_forms(Pvt_Int) = New Chat
        With Chat_forms(Pvt_Int)
            .MdiParent = Me
            .Index = Pvt_Int
            .Main = False
            For Each Tmp_User As User_Type In User
                If Tmp_User.Name.Equals(User_list.SelectedItem.ToString) Then
                    .PVT_user = Tmp_User
                    Exit For
                End If
            Next
            .Show()
        End With
    End Sub

    Private Sub Tray_popup_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Tray_popup.Opening
        PrivateChatToToolStripMenuItem.DropDownItems.Clear()
        For Each Tmp_User As User_Type In User
            If Not (Tmp_User.Hidden Or Tmp_User.Ignore Or Tmp_User.Local) Then
                PrivateChatToToolStripMenuItem.DropDownItems.Add(Tmp_User.Name)
            End If
        Next
        If PrivateChatToToolStripMenuItem.DropDownItems.Count = 0 Then
            PrivateChatToToolStripMenuItem.DropDownItems.Add("No Users Online")
            PrivateChatToToolStripMenuItem.DropDownItems.Item(0).Enabled = False
        End If
    End Sub

    Private Sub SendFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SendFileToolStripMenuItem.Click
        ' ------ Init file sending here...
        Dim Tmp_File As String
        Pvt_Int = UBound(File_forms) + 1
        ReDim Preserve File_forms(Pvt_Int)
        File_forms(Pvt_Int) = New Files
        With File_forms(Pvt_Int)
            .MdiParent = Me
            .Index = Pvt_Int
            Tmp_File = .Init()
            .Show()
            If Tmp_File <> "" Then
                For Each Tmp_User As User_Type In User
                    If Tmp_User.Name.Equals(User_list.SelectedItem.ToString) Then
                        Dim Dest_IP As New Net.IPEndPoint(Tmp_User.IP, L_Port)
                        UDPSock.Send("FILE:" & User(0).IP.ToString & ":" & User(0).Name & ":" & CStr(.Port) & ":" & Return_File(Tmp_File), Dest_IP)
                        Exit For
                    End If
                Next Tmp_User
            Else
                Close_File(Pvt_Int)
            End If
        End With
    End Sub

End Class
